=== debian/changelog ===
libreswan (1:3.12-1) precise; urgency=low

  * Update to 3.12-1

  The real changelog is in /usr/share/doc/libreswan/changelog.gz

  This package is NOT an official Debian/Ubuntu package. Please do
  not file any Debian/Ubuntu bug reports for this package but contact
  <dev@libreswan.org> if you have a problem.

 -- Unknown User <unknown@libreswan.org>  Sun, 25 Nov 2012 19:00:00 +0200
